

<img src="img/dfca_v1-profile_tiny.jpg" width="24"> Digital Feudalism Counter Action (DFCA <img src="identicons/0.2.0.png" width="24" alt="SHA-256 identicon of DFCA 0.2.0"> 0.2.0 beta)
=======================================

We can no longer wait for politicians to enforce antitrust law. Enforce it yourself by blocking the *digital feudalists* and importantly __get a little popup notification__ when a program attempts to contact them (pictured). Also, with a few minor customizations you can see *__which__* program attempted to contact said feudalist. See below image.

<img src="img/dfca_v1-hero_digital-feudalism-counter-action_blocking-google_photography-cristina-gottardi-unsplash.webp" width="700" height="467" alt="Image of DFCA (Digital Feudalism Counter Action) giving a small on-screen notification when an application, in this case Firefox, tried to connect to the digital feudalist, Google, with a message, 'Google out blocked' in bold, and below that, 'Firefox ~ DFCA Antitrust Law'."><br>&nbsp;

While enforcing __DFCA Antitrust Law__, you'll see just how bad our once-vibrant internet has become. While the *digital feudalists* shape our culture, ideology, language, the people we know, and what we value, the situation worsens by the day. It is impossible to predict when the worst possible harm will occur, but with so many highly publicized platforms under the feudalists' surveillance and control, the worst possible harm may *already* be unavoidable.

It is a matter of public record and must also be noted that the *digital feudalists* are military-contracted. Similarly countless independent observers have over the years revealed the feudalists' links to the industrial security complex, whose purpose it is to divide and fragment the general population to secure the privileges of the most wealthy.

The *digital feudalists* are a threat to human civilization as we know, or should we say, 'knew' it.

__This 'DFCA Antitrust Law' setup will__:

  - block IP addresses of the following *digital feudalists*:
    - Amazon,
    - Cloudflare,
    - Microsoft,
    - Google,
    - Musk (eg. SpaceX, Twitter etc),
    - Oracle,
    - Alibaba,
    - Akamai,
    - Tencent,
    - Apple, and
    - Facebook.

It also, importantly, __tells you when it blocks via a popup message__; vital for debugging. The popup identifies:
  - the exact feudalist, and
  - the application that made the request, depending on 'isolation groups' you make (see instructions in the text file). Currently this is a manual part of the process but the guide makes it easy. Ideas toward [automating this part of the process](#future-development).

<small>__NOTE: You will want to have [Tor Browser](https://torproject.org) installed, as 40-90% of websites will not be accessible without it, depending on what you search for.__ For example, sites related to art, technology, connecting with people, e-commerce, AI, government and cryptocurrency (including legacy banking and finance) are most dominated (or attacked) by *digital feudalists*. Having said that, there are many such sites that load okay using DFCA because 'phoning home' to the feudalist is not necessary to load page contents.</small>



## Easy setup

0. Requires linux. <sub><sup>Why do this on anything other than a free-license, open-source (FOSS) operating system that respects it users?</sup></sub> It may be desirable to have __ClamAV__ installed (sure, a FOSS anti-virus for linux, believe it or not). Because you will not be talking to *digital feudalists* you *__may__* be a more desirable target by actors that have connections with those feudalists. So please consider `clamav`.

1. Ensure __[Tor Browser](https://torproject.org)__ and `torsocks` are installed and working.

2. Get the <a href="dfca/raw/branch/master/dfca_0.2.0.tar"><img src="img/dfca_v1-profile_tiny.jpg" width="17">  __DFCA 0.2.0__ <img src="identicons/0.2.0.png" width="17" alt="SHA-256 identicon of DFCA 0.2.0"> __(beta)__</a> package, plus its <a href="dfca/raw/branch/master/dfca_0.2.0.tar.asc">__PGP signature__</a> and <a href="dfca/raw/branch/master/unsender-pubkey.asc">__Unsender's public key__</a> to verify its authenticity using cryptography. If this is your first install go to '[First install](#first-install-beginner-friendly)' section below. Otherwise, check the update is signed by Unsender, or a key you know. The update should be as easy to read and follow as the original install and/or other updates.

3. __Spend 15 minutes or so to enter the well-documented commands__ (if updating, the process may be automated and take less time). Yes, during setup you'll see well-documented bash-script and maybe learn some GNU/linux computer tricks! Double win!!

You're set! Congratulations on joining the resistance!

<small>__Want notifications without actually blocking?__ <sub>If you are not ready to block the *digital feudalists* but want to see feudalism with your own eyes, then simply don't add any `iptables` commands with the word `REJECT` at the end*. At any time in the future you can go back and add them, *and you won't regret it.* * __WARNING:__ False positives may result, and may lead you to suspect a site will not function without a feudalist, when in fact the popup only appeared when the website attempted to fetch ads or unnecessary javascript, trackers, fonts, images and/or styles. *__A site's content may load while blocking, and possibly load faster and perform better, without scripts that often slow down one's entire computer system!__*</sub></small>


### First install (beginner friendly)

  - The command line or 'terminal' is used in these instructions. To open the terminal, try `Ctrl+Alt+T`.
  - The __GPG (GNU Privacy Guard)__ software will be used for cryptographic authenticity. A nice resource to learn about `gpg` is the [PGP Compendium](https://files.gpg4win.org/doc/gpg4win-compendium-en.pdf) ([DE](https://files.gpg4win.org/doc/gpg4win-compendium-de.pdf)).
    - A more technical "(man)ual" is accessible without the internet from your terminal with:
      - `man gpg`
    - Navigating 'man' pages is easy with arrow keys, 'PgUp' and 'PgDn'. Quit with 'q'. Search 'man' pages with (/) forward slash, like so:
      - `/search for this phrase`
  - Check that the 'tar' compressed file was signed by Unsender's key (ie. the fingerprint should match 'A264 08BB 063F E001 8B1A 37CC F663 BE9B E932 748F')
    - `gpg --verify-files dfca_0.2.0.tar.asc`
  - After opening and extracting the contents of the 'tar' file. Skim over the instructions in the text file to confirm its worth.
  - When you deem __DFCA Antitrust Law__ worthy, please take the time to exercise good software hygiene, and not just on this occasion but on all occasions moving forward. Without the feudalists possibly 'holding your hand' (and engaging in repression at the same), and once particular entities learn that you no longer feed them data through their digital 'partners in (cyber)crime', you may need to be extra careful to stay safe. If software is not offered by your linux distribution package managers, getting copies of software from as many quality random sources as possible and comparing them with the `diff` command or by their unique hash (see `shasum`) may be needed. It means ensuring software is signed by reputatable keys. It means `clamav` anti-virus might now be installed. It means researching software; ask yourself are different communities vetting or using it? It means resisting 'bloatware' spanning tens of megabytes for no justifiable reason. It means, if you are not a programmer, having a computer savvy friend look at software and maybe even attempting to build the software from its source code, or just checking source code every so often.
    - Import Unsender's cryptographic public key to help verify authenticity of future updates:
      - `gpg --import unsender-pubkey.asc`
    - If successful, you should see the key in your keyring with:
      - `gpg --list-keys`
    - You'll get a message saying the key itself is untrusted, so assign a trust level to it. First, select the key for 'editing'...:
      - `gpg --edit-key Unsender`
      -  ...then at the `gpg>` prompt type `trust` and give it a `3` ('marginal' trust). What we are doing here is using an approach to *key management* called 'trust-on-first-use'. The longer a key is used to deliver quality software the easier it *__can__* be to trust it, but because Unsender will remain anonymous, best practice is to read new code changes. Don't trust Unsender. In fact don't trust anyone but yourself and people you give a portion of your destiny to. One mantra of the cypherpunk is, "*Don't trust... verify*".
  - Some tasks will be easier and some harder as a result of blocking feudalists. __Search will be better.__ Bookmark search engines like __[Metager](https://metager.org)__&nbsp;([I2P](http://metager.i2p)&nbsp;[B32](http://4zdcetlcp3tdg5h23gd3aeyzbvodepid7a6mb3w4qvxkdnm2by6q.b32.i2p),&nbsp;[Tor](http://metagerv65pwclop2rsfzg4jwowpavpwd6grhhlvdgsswvo6ii4akgyd.onion)), __[Mojeek](https://www.mojeek.com/)__&nbsp;([I2P](http://mojeek.i2p/)&nbsp;[B32](http://zc347qqc4pvo7lf73rhuhthd3i3g2v5zgnsqdoklexx2bcau7rgq.b32.i2p)), __[Startpage](https://startpage.com)__, __[Qwant](https://lite.qwant.com)__ and __[Yandex](https://yandex.com/)__, and search aggregator instances like __[SearXNG](https://searx.space/data/instances.json)__ to name a few. The I2P and Tor networks also have their own search providers like __Ahmia__&nbsp;([I2P](http://i2psearch.i2p)&nbsp;[B32](http://d4jtslmsku66nmq7u3mpyhqb3cw3operuhldvegkectmakmf6jiq.b32.i2p),&nbsp;[Tor](http://juhanurmihxlp77nkq76byazcldy2hlmovfu2epvl5ankdibsot4csyd.onion/)).
  - It must be repeated, __bookmark the above__ search sites. If you think DuckDuckGo is the pièce de résistance, you'll quickly learn its a product served *from Microsoft servers!* 🔥🔥🔥
  - Continue to step three (3) of [Easy Setup](#easy-setup).


### Emergency access

For '*desperate access*' to a feudalist's IP address, either:
  - use __Tor Browser__, or
  - if the site blocks Tor access you might be able to view it via __[The Internet Archive (IA)](https://web.archive.org/)__ (aka The Wayback Machine).
    - For quick access to the IA, ensure [`web.archive.org`](https://web.archive.org/) is bookmarked so you only need to...
    - type 'web' in the address bar,
    - select the bookmarked address from the dropdown menu so it goes into your address bar, and then append the address you must visit. Eg.:
      - `web.archive.org/https://must-see.site/life-in-danger-if-I-don't-see-page-on-unethical-site/`
      - Done.
      - <small>NOTE: The site may ban the IA too. Alternatively, if the IA has never archived the page, you may be prompted to start an archive process that may take a minute or so to complete. Go have your favorite drink and wait. 🫖🧋🥛🍺🍨😋🥃🍸🍹🥤🍵</small>, or
  - the last resort is to disable blocking temporarily (see 'Desperate Access' in the text instructions).

Removing yourself from their system and rebuilding is not going to be the most easy experience, but <u>*do*</u> remain steadfast in your resistance to the *digital feudalists* and their enablers who use (and thus feed) them. Just like you can buy books without Amazon, __you *should be able to* do everything you need without the feudalists.__ It may take longer at times but that is the cost of having *ethical standards*. There is a saying, "the struggle reveals the truth." We can only stop the feudalism if we are prepared to be ethical *__at all times__*, not just on Sunday mornings. 



## Future development

- __Two-click updates harnessing decentralized method of distribution (eg. torrent, IPFS).__ If not signed by expected key(s) issue warning. Options being; <small>*Download proposed update...*</small> (or <small>*View proposed update...*</small>), <small>*Not now*</small>, <small>*Remind me in a few days*</small>, and if the update has been downloaded <small>*Ignore proposed update*</small>. Use random jitter in all time delays. Starting from DFCA 0.2.0 <img src="identicons/0.2.0.png" width="17" alt="SHA-256 identicon of DFCA 0.2.0"> each update/version should display an __identicon__ (see [Visual Versions](#visual-versioning)) to distinguish between potential updates.
- __Making the 'txt' file a bash script that is still human-readable__... hopefully moreso! And,
- __Automate creation of 'app isolation groups'__ by finding all `.desktop` files on system, asking user which applications they want to isolate (with an 'All Applications' option?), making individual DFCA groups for them (noting limit to groupname length, a mapping system completely distinct from the current setup may need to be developed 😑?) and then produce the custom desktop files to run applications inside said groups (may be tricky to automate wrapping of complex launch scripts but ultimately a good thing to automate). At the same time implement pre and post-install hooks that would seek to re-produce new and custom, updated`.desktop` files, and likely group-mappings(?), asking user with respect to newly installed applications whether they would like to produce an isolation group for it (not asked if 'All applications' option was selected), and also automatically discarding subsequently unused DFCA groups on install <small>(feedback welcomed. Doing the 'isolation' automatically is expected to be difficult, incl. difficult to read code of, which is a priority of this project).</small>.



## Visual Versioning

If we imagine that __DFCA Antitrust Law__ becomes so popular that there are multiple versions or forks vying for your attention. By displaying '__identicon__' alongside each potential update/version/fork it becomes easier to distinguish between them. 'Identicons' would be difficult to spoof because they would be based on the SHA-256 hash of a file. Here are some identicons.

![Image of green checked identicon](identicons/example1.png) ![Brown fan identicon](identicons/example2.png) ![White squares on purple identicon](identicons/example3.png) ![Another yellowish-green identicon](identicons/example4.png) ![Dashed outline](identicons/example5.png) ![Sunburst](identicons/example6.png) ![...and finally a white diamond icon](identicons/example7.png) 

In the below script we generate a random but distinct 'identicon' using the version of that is [included with]((http://127.0.0.1:7657/imagegen/)) __i2prouter__. It is the one you see for the latest version, <a href="dfca/raw/branch/master/dfca_0.2.0.tar"><img src="img/dfca_v1-profile_tiny.jpg" width="17">&nbsp;__DFCA&nbsp;0.2.0__&nbsp;<img src="identicons/0.2.0.png" width="17" alt="SHA-256 identicon of DFCA 0.2.0"> __(beta)__</a>. Generating such requires `i2prouter` be running:

```bash
 ##   Store SHA256 of file...
hash256=$(shasum -a 256 'dfca_0.2.0.tar' | cut --delimiter=' ' --field=1) \
 ##   Generate from locally hosted I2P the 'identicon' image, (s)ize 64 pixels, (O)utput as PNG.
wget "http://localhost:7657/imagegen/id?c=${hash256}&s=64" -O "identicons/0.2.0.png"
```
By changing the input file above that is hashed with `shasum`, its possible to create an 'identicon' for *__any__* file!



## List of mirrors (incomplete)

- via [torrent](torrents/DigitalFeudalismCounterAction_0.2.0+(Antitrust+law+by+CYPHERPUNKS).torrent) (torrent file also available from [tracker2.postman.i2p](http://tracker2.postman.i2p/?view=TorrentDetail&id=69969))
- more soon...



## Ending the *digital feudalism* and the importance of remaining vigilant

It is well-known that only a tiny number of people (3%) need participate in a counter action movement for it to snowball into popular effect and have a quality outcome. Therefore, one person enacting something akin to __DFCA Antitrust Law__ will be worth 33 people not doing so! Together, we can make emancipation from *digital feudalism* a reality.

In your journey you will discover many great decentralized technologies and services that you may never have if you didn't block the feudalists. __Share news of them far and wide in both online networks and in the meatspace__. Don't forget to share __DFCA Antitrust Law__ when it helps you, too. After the digital feudalists are gone, we must remain vigilant of coercive powers seeking to infiltrate and dominate. There will always be those who seek extreme power, so stay wise.

__Thanks for your consideration.__

*~ Unsender*

> <img src="img/dfca_v1-profile_digital-feudalism-counter-action_blocking-google_photography-cristina-gottardi-unsplash.webp" width="250" height="250" alt="Image of DFCA Antitrust Law depicting the same as the above image but is square and suitable as an avatar or profile image. It is indeed the profile image of this DFCA repo." >
>
> "Adopt the code you want to see in the world."